diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mm-imx25.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mm-imx25.c
--- linux-3.0/arch/arm/mach-imx/mm-imx25.c	2011-06-22 15:07:07.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mm-imx25.c	2011-10-18 04:06:23.000000000 +0000
@@ -24,10 +24,10 @@
 #include <asm/mach/map.h>
 
 #include <mach/common.h>
+#include <mach/devices-common.h>
 #include <mach/hardware.h>
 #include <mach/mx25.h>
 #include <mach/iomux-v3.h>
-#include <mach/gpio.h>
 #include <mach/irqs.h>
 
 /*
@@ -57,16 +57,40 @@ void __init imx25_init_early(void)
 	mxc_arch_reset_init(MX25_IO_ADDRESS(MX25_WDOG_BASE_ADDR));
 }
 
-static struct mxc_gpio_port imx25_gpio_ports[] = {
-	DEFINE_IMX_GPIO_PORT_IRQ(MX25, 0, 1, MX25_INT_GPIO1),
-	DEFINE_IMX_GPIO_PORT_IRQ(MX25, 1, 2, MX25_INT_GPIO2),
-	DEFINE_IMX_GPIO_PORT_IRQ(MX25, 2, 3, MX25_INT_GPIO3),
-	DEFINE_IMX_GPIO_PORT_IRQ(MX25, 3, 4, MX25_INT_GPIO4),
-};
-
 void __init mx25_init_irq(void)
 {
 	mxc_init_irq(MX25_IO_ADDRESS(MX25_AVIC_BASE_ADDR));
-	mxc_gpio_init(imx25_gpio_ports,	ARRAY_SIZE(imx25_gpio_ports));
 }
 
+static struct sdma_script_start_addrs imx25_sdma_script __initdata = {
+	.ap_2_ap_addr = 729,
+	.uart_2_mcu_addr = 904,
+	.per_2_app_addr = 1255,
+	.mcu_2_app_addr = 834,
+	.uartsh_2_mcu_addr = 1120,
+	.per_2_shp_addr = 1329,
+	.mcu_2_shp_addr = 1048,
+	.ata_2_mcu_addr = 1560,
+	.mcu_2_ata_addr = 1479,
+	.app_2_per_addr = 1189,
+	.app_2_mcu_addr = 770,
+	.shp_2_per_addr = 1407,
+	.shp_2_mcu_addr = 979,
+};
+
+static struct sdma_platform_data imx25_sdma_pdata __initdata = {
+	.fw_name = "sdma-imx25.bin",
+	.script_addrs = &imx25_sdma_script,
+};
+
+void __init imx25_soc_init(void)
+{
+	/* i.mx25 has the i.mx31 type gpio */
+	mxc_register_gpio("imx31-gpio", 0, MX25_GPIO1_BASE_ADDR, SZ_16K, MX25_INT_GPIO1, 0);
+	mxc_register_gpio("imx31-gpio", 1, MX25_GPIO2_BASE_ADDR, SZ_16K, MX25_INT_GPIO2, 0);
+	mxc_register_gpio("imx31-gpio", 2, MX25_GPIO3_BASE_ADDR, SZ_16K, MX25_INT_GPIO3, 0);
+	mxc_register_gpio("imx31-gpio", 3, MX25_GPIO4_BASE_ADDR, SZ_16K, MX25_INT_GPIO4, 0);
+
+	/* i.mx25 has the i.mx35 type sdma */
+	imx_add_imx_sdma("imx35-sdma", MX25_SDMA_BASE_ADDR, MX25_INT_SDMA, &imx25_sdma_pdata);
+}
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mm-imx27.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mm-imx27.c
--- linux-3.0/arch/arm/mach-imx/mm-imx27.c	2011-06-22 15:07:07.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mm-imx27.c	2011-10-18 04:06:23.000000000 +0000
@@ -22,9 +22,9 @@
 #include <linux/init.h>
 #include <mach/hardware.h>
 #include <mach/common.h>
+#include <mach/devices-common.h>
 #include <asm/pgtable.h>
 #include <asm/mach/map.h>
-#include <mach/gpio.h>
 #include <mach/irqs.h>
 #include <mach/iomux-v1.h>
 
@@ -70,17 +70,20 @@ void __init imx27_init_early(void)
 			MX27_NUM_GPIO_PORT);
 }
 
-static struct mxc_gpio_port imx27_gpio_ports[] = {
-	DEFINE_IMX_GPIO_PORT_IRQ(MX27, 0, 1, MX27_INT_GPIO),
-	DEFINE_IMX_GPIO_PORT(MX27, 1, 2),
-	DEFINE_IMX_GPIO_PORT(MX27, 2, 3),
-	DEFINE_IMX_GPIO_PORT(MX27, 3, 4),
-	DEFINE_IMX_GPIO_PORT(MX27, 4, 5),
-	DEFINE_IMX_GPIO_PORT(MX27, 5, 6),
-};
-
 void __init mx27_init_irq(void)
 {
 	mxc_init_irq(MX27_IO_ADDRESS(MX27_AVIC_BASE_ADDR));
-	mxc_gpio_init(imx27_gpio_ports,	ARRAY_SIZE(imx27_gpio_ports));
+}
+
+void __init imx27_soc_init(void)
+{
+	/* i.mx27 has the i.mx21 type gpio */
+	mxc_register_gpio("imx21-gpio", 0, MX27_GPIO1_BASE_ADDR, SZ_256, MX27_INT_GPIO, 0);
+	mxc_register_gpio("imx21-gpio", 1, MX27_GPIO2_BASE_ADDR, SZ_256, MX27_INT_GPIO, 0);
+	mxc_register_gpio("imx21-gpio", 2, MX27_GPIO3_BASE_ADDR, SZ_256, MX27_INT_GPIO, 0);
+	mxc_register_gpio("imx21-gpio", 3, MX27_GPIO4_BASE_ADDR, SZ_256, MX27_INT_GPIO, 0);
+	mxc_register_gpio("imx21-gpio", 4, MX27_GPIO5_BASE_ADDR, SZ_256, MX27_INT_GPIO, 0);
+	mxc_register_gpio("imx21-gpio", 5, MX27_GPIO6_BASE_ADDR, SZ_256, MX27_INT_GPIO, 0);
+
+	imx_add_imx_dma();
 }
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mm-imx31.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mm-imx31.c
--- linux-3.0/arch/arm/mach-imx/mm-imx31.c	2011-08-29 03:03:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mm-imx31.c	2011-10-18 04:06:23.000000000 +0000
@@ -24,9 +24,9 @@
 #include <asm/mach/map.h>
 
 #include <mach/common.h>
+#include <mach/devices-common.h>
 #include <mach/hardware.h>
 #include <mach/iomux-v3.h>
-#include <mach/gpio.h>
 #include <mach/irqs.h>
 
 static struct map_desc mx31_io_desc[] __initdata = {
@@ -53,14 +53,39 @@ void __init imx31_init_early(void)
 	mxc_arch_reset_init(MX31_IO_ADDRESS(MX31_WDOG_BASE_ADDR));
 }
 
-static struct mxc_gpio_port imx31_gpio_ports[] = {
-	DEFINE_IMX_GPIO_PORT_IRQ(MX31, 0, 1, MX31_INT_GPIO1),
-	DEFINE_IMX_GPIO_PORT_IRQ(MX31, 1, 2, MX31_INT_GPIO2),
-	DEFINE_IMX_GPIO_PORT_IRQ(MX31, 2, 3, MX31_INT_GPIO3),
-};
-
 void __init mx31_init_irq(void)
 {
 	mxc_init_irq(MX31_IO_ADDRESS(MX31_AVIC_BASE_ADDR));
-	mxc_gpio_init(imx31_gpio_ports,	ARRAY_SIZE(imx31_gpio_ports));
+}
+
+static struct sdma_script_start_addrs imx31_to1_sdma_script __initdata = {
+	.per_2_per_addr = 1677,
+};
+
+static struct sdma_script_start_addrs imx31_to2_sdma_script __initdata = {
+	.ap_2_ap_addr = 423,
+	.ap_2_bp_addr = 829,
+	.bp_2_ap_addr = 1029,
+};
+
+static struct sdma_platform_data imx31_sdma_pdata __initdata = {
+	.fw_name = "sdma-imx31-to2.bin",
+	.script_addrs = &imx31_to2_sdma_script,
+};
+
+void __init imx31_soc_init(void)
+{
+	int to_version = mx31_revision() >> 4;
+
+	mxc_register_gpio("imx31-gpio", 0, MX31_GPIO1_BASE_ADDR, SZ_16K, MX31_INT_GPIO1, 0);
+	mxc_register_gpio("imx31-gpio", 1, MX31_GPIO2_BASE_ADDR, SZ_16K, MX31_INT_GPIO2, 0);
+	mxc_register_gpio("imx31-gpio", 2, MX31_GPIO3_BASE_ADDR, SZ_16K, MX31_INT_GPIO3, 0);
+
+	if (to_version == 1) {
+		strncpy(imx31_sdma_pdata.fw_name, "sdma-imx31-to1.bin",
+			strlen(imx31_sdma_pdata.fw_name));
+		imx31_sdma_pdata.script_addrs = &imx31_to1_sdma_script;
+	}
+
+	imx_add_imx_sdma("imx31-sdma", MX31_SDMA_BASE_ADDR, MX31_INT_SDMA, &imx31_sdma_pdata);
 }
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mm-imx35.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mm-imx35.c
--- linux-3.0/arch/arm/mach-imx/mm-imx35.c	2011-08-29 03:03:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mm-imx35.c	2011-10-18 04:06:23.000000000 +0000
@@ -25,9 +25,9 @@
 #include <asm/hardware/cache-l2x0.h>
 
 #include <mach/common.h>
+#include <mach/devices-common.h>
 #include <mach/hardware.h>
 #include <mach/iomux-v3.h>
-#include <mach/gpio.h>
 #include <mach/irqs.h>
 
 static struct map_desc mx35_io_desc[] __initdata = {
@@ -50,14 +50,60 @@ void __init imx35_init_early(void)
 	mxc_arch_reset_init(MX35_IO_ADDRESS(MX35_WDOG_BASE_ADDR));
 }
 
-static struct mxc_gpio_port imx35_gpio_ports[] = {
-	DEFINE_IMX_GPIO_PORT_IRQ(MX35, 0, 1, MX35_INT_GPIO1),
-	DEFINE_IMX_GPIO_PORT_IRQ(MX35, 1, 2, MX35_INT_GPIO2),
-	DEFINE_IMX_GPIO_PORT_IRQ(MX35, 2, 3, MX35_INT_GPIO3),
-};
-
 void __init mx35_init_irq(void)
 {
 	mxc_init_irq(MX35_IO_ADDRESS(MX35_AVIC_BASE_ADDR));
-	mxc_gpio_init(imx35_gpio_ports,	ARRAY_SIZE(imx35_gpio_ports));
+}
+
+static struct sdma_script_start_addrs imx35_to1_sdma_script __initdata = {
+	.ap_2_ap_addr = 642,
+	.uart_2_mcu_addr = 817,
+	.mcu_2_app_addr = 747,
+	.uartsh_2_mcu_addr = 1183,
+	.per_2_shp_addr = 1033,
+	.mcu_2_shp_addr = 961,
+	.ata_2_mcu_addr = 1333,
+	.mcu_2_ata_addr = 1252,
+	.app_2_mcu_addr = 683,
+	.shp_2_per_addr = 1111,
+	.shp_2_mcu_addr = 892,
+};
+
+static struct sdma_script_start_addrs imx35_to2_sdma_script __initdata = {
+	.ap_2_ap_addr = 729,
+	.uart_2_mcu_addr = 904,
+	.per_2_app_addr = 1597,
+	.mcu_2_app_addr = 834,
+	.uartsh_2_mcu_addr = 1270,
+	.per_2_shp_addr = 1120,
+	.mcu_2_shp_addr = 1048,
+	.ata_2_mcu_addr = 1429,
+	.mcu_2_ata_addr = 1339,
+	.app_2_per_addr = 1531,
+	.app_2_mcu_addr = 770,
+	.shp_2_per_addr = 1198,
+	.shp_2_mcu_addr = 979,
+};
+
+static struct sdma_platform_data imx35_sdma_pdata __initdata = {
+	.fw_name = "sdma-imx35-to2.bin",
+	.script_addrs = &imx35_to2_sdma_script,
+};
+
+void __init imx35_soc_init(void)
+{
+	int to_version = mx35_revision() >> 4;
+
+	/* i.mx35 has the i.mx31 type gpio */
+	mxc_register_gpio("imx31-gpio", 0, MX35_GPIO1_BASE_ADDR, SZ_16K, MX35_INT_GPIO1, 0);
+	mxc_register_gpio("imx31-gpio", 1, MX35_GPIO2_BASE_ADDR, SZ_16K, MX35_INT_GPIO2, 0);
+	mxc_register_gpio("imx31-gpio", 2, MX35_GPIO3_BASE_ADDR, SZ_16K, MX35_INT_GPIO3, 0);
+
+	if (to_version == 1) {
+		strncpy(imx35_sdma_pdata.fw_name, "sdma-imx35-to1.bin",
+			strlen(imx35_sdma_pdata.fw_name));
+		imx35_sdma_pdata.script_addrs = &imx35_to1_sdma_script;
+	}
+
+	imx_add_imx_sdma("imx35-sdma", MX35_SDMA_BASE_ADDR, MX35_INT_SDMA, &imx35_sdma_pdata);
 }
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mx31lite-db.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mx31lite-db.c
--- linux-3.0/arch/arm/mach-imx/mx31lite-db.c	2011-08-29 03:03:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mx31lite-db.c	2011-10-18 04:06:23.000000000 +0000
@@ -161,7 +161,7 @@ static const struct spi_imx_master spi0_
 
 /* GPIO LEDs */
 
-static struct gpio_led litekit_leds[] = {
+static const struct gpio_led litekit_leds[] __initconst = {
 	{
 		.name           = "GPIO0",
 		.gpio           = IOMUX_TO_GPIO(MX31_PIN_COMPARE),
@@ -176,19 +176,12 @@ static struct gpio_led litekit_leds[] =
 	}
 };
 
-static struct gpio_led_platform_data litekit_led_platform_data = {
+static const struct gpio_led_platform_data
+		litekit_led_platform_data __initconst = {
 	.leds           = litekit_leds,
 	.num_leds       = ARRAY_SIZE(litekit_leds),
 };
 
-static struct platform_device litekit_led_device = {
-	.name   = "leds-gpio",
-	.id     = -1,
-	.dev    = {
-		.platform_data = &litekit_led_platform_data,
-	},
-};
-
 void __init mx31lite_db_init(void)
 {
 	mxc_iomux_setup_multiple_pins(litekit_db_board_pins,
@@ -197,7 +190,7 @@ void __init mx31lite_db_init(void)
 	imx31_add_imx_uart0(&uart_pdata);
 	imx31_add_mxc_mmc(0, &mmc_pdata);
 	imx31_add_spi_imx0(&spi0_pdata);
-	platform_device_register(&litekit_led_device);
+	gpio_led_register_device(-1, &litekit_led_platform_data);
 	imx31_add_imx2_wdt(NULL);
 	imx31_add_mxc_rtc(NULL);
 }
diff -NurpP --minimal linux-3.0/arch/arm/mach-integrator/include/mach/hardware.h torvalds-linux-v3.1-rc10/arch/arm/mach-integrator/include/mach/hardware.h
--- linux-3.0/arch/arm/mach-integrator/include/mach/hardware.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-integrator/include/mach/hardware.h	2011-10-18 04:06:23.000000000 +0000
@@ -32,13 +32,6 @@
 #define IO_SIZE			0x0B000000                 // How much?
 #define IO_START		INTEGRATOR_HDR_BASE        // PA of IO
 
-#define PCIMEM_BASE		PCI_MEMORY_VADDR
-
-#define pcibios_assign_all_busses()	1
-
-#define PCIBIOS_MIN_IO		0x6000
-#define PCIBIOS_MIN_MEM 	0x00100000
-
 /* macro to get at IO space when running virtually */
 #ifdef CONFIG_MMU
 #define IO_ADDRESS(x)	(((x) & 0x000fffff) | (((x) >> 4) & 0x0ff00000) | IO_BASE)
diff -NurpP --minimal linux-3.0/arch/arm/mach-integrator/integrator_ap.c torvalds-linux-v3.1-rc10/arch/arm/mach-integrator/integrator_ap.c
--- linux-3.0/arch/arm/mach-integrator/integrator_ap.c	2011-08-29 03:03:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-integrator/integrator_ap.c	2011-10-18 04:06:23.000000000 +0000
@@ -32,6 +32,7 @@
 #include <linux/interrupt.h>
 #include <linux/io.h>
 #include <linux/mtd/physmap.h>
+#include <video/vga.h>
 
 #include <mach/hardware.h>
 #include <mach/platform.h>
@@ -154,6 +155,7 @@ static struct map_desc ap_io_desc[] __in
 static void __init ap_map_io(void)
 {
 	iotable_init(ap_io_desc, ARRAY_SIZE(ap_io_desc));
+	vga_base = PCI_MEMORY_VADDR;
 }
 
 #define INTEGRATOR_SC_VALID_INT	0x003fffff
@@ -337,15 +339,15 @@ static unsigned long timer_reload;
 static void integrator_clocksource_init(u32 khz)
 {
 	void __iomem *base = (void __iomem *)TIMER2_VA_BASE;
-	u32 ctrl = TIMER_CTRL_ENABLE;
+	u32 ctrl = TIMER_CTRL_ENABLE | TIMER_CTRL_PERIODIC;
 
 	if (khz >= 1500) {
 		khz /= 16;
-		ctrl = TIMER_CTRL_DIV16;
+		ctrl |= TIMER_CTRL_DIV16;
 	}
 
-	writel(ctrl, base + TIMER_CTRL);
 	writel(0xffff, base + TIMER_LOAD);
+	writel(ctrl, base + TIMER_CTRL);
 
 	clocksource_mmio_init(base + TIMER_VALUE, "timer2",
 		khz * 1000, 200, 16, clocksource_mmio_readl_down);
diff -NurpP --minimal linux-3.0/arch/arm/mach-integrator/pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-integrator/pci.c
--- linux-3.0/arch/arm/mach-integrator/pci.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-integrator/pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -95,7 +95,7 @@ static int irq_tab[4] __initdata = {
  * map the specified device/slot/pin to an IRQ.  This works out such
  * that slot 9 pin 1 is INT0, pin 2 is INT1, and slot 10 pin 1 is INT1.
  */
-static int __init integrator_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init integrator_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	int intnr = ((slot - 9) + (pin - 1)) & 3;
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-integrator/pci_v3.c torvalds-linux-v3.1-rc10/arch/arm/mach-integrator/pci_v3.c
--- linux-3.0/arch/arm/mach-integrator/pci_v3.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-integrator/pci_v3.c	2011-10-18 04:06:23.000000000 +0000
@@ -502,6 +502,9 @@ void __init pci_v3_preinit(void)
 	unsigned int temp;
 	int ret;
 
+	pcibios_min_io = 0x6000;
+	pcibios_min_mem = 0x00100000;
+
 	/*
 	 * Hook in our fault handler for PCI errors
 	 */
diff -NurpP --minimal linux-3.0/arch/arm/mach-iop13xx/include/mach/hardware.h torvalds-linux-v3.1-rc10/arch/arm/mach-iop13xx/include/mach/hardware.h
--- linux-3.0/arch/arm/mach-iop13xx/include/mach/hardware.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-iop13xx/include/mach/hardware.h	2011-10-18 04:06:23.000000000 +0000
@@ -2,18 +2,11 @@
 #define __ASM_ARCH_HARDWARE_H
 #include <asm/types.h>
 
-#define pcibios_assign_all_busses() 1
-
 #ifndef __ASSEMBLY__
-extern unsigned long iop13xx_pcibios_min_io;
-extern unsigned long iop13xx_pcibios_min_mem;
 extern u16 iop13xx_dev_id(void);
 extern void iop13xx_set_atu_mmr_bases(void);
 #endif
 
-#define PCIBIOS_MIN_IO      (iop13xx_pcibios_min_io)
-#define PCIBIOS_MIN_MEM     (iop13xx_pcibios_min_mem)
-
 /*
  * Generic chipset bits
  *
diff -NurpP --minimal linux-3.0/arch/arm/mach-iop13xx/iq81340mc.c torvalds-linux-v3.1-rc10/arch/arm/mach-iop13xx/iq81340mc.c
--- linux-3.0/arch/arm/mach-iop13xx/iq81340mc.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-iop13xx/iq81340mc.c	2011-10-18 04:06:23.000000000 +0000
@@ -30,7 +30,7 @@
 extern int init_atu; /* Flag to select which ATU(s) to initialize / disable */
 
 static int __init
-iq81340mc_pcix_map_irq(struct pci_dev *dev, u8 idsel, u8 pin)
+iq81340mc_pcix_map_irq(const struct pci_dev *dev, u8 idsel, u8 pin)
 {
 	switch (idsel) {
 	case 1:
diff -NurpP --minimal linux-3.0/arch/arm/mach-iop13xx/pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-iop13xx/pci.c
--- linux-3.0/arch/arm/mach-iop13xx/pci.c	2011-06-22 15:07:07.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-iop13xx/pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -39,8 +39,6 @@ u32 iop13xx_atue_mem_base;
 u32 iop13xx_atux_mem_base;
 size_t iop13xx_atue_mem_size;
 size_t iop13xx_atux_mem_size;
-unsigned long iop13xx_pcibios_min_io = 0;
-unsigned long iop13xx_pcibios_min_mem = 0;
 
 EXPORT_SYMBOL(iop13xx_atue_mem_base);
 EXPORT_SYMBOL(iop13xx_atux_mem_base);
@@ -390,7 +388,7 @@ static int iop13xx_atue_pci_status(int c
 }
 
 static int
-iop13xx_pcie_map_irq(struct pci_dev *dev, u8 idsel, u8 pin)
+iop13xx_pcie_map_irq(const struct pci_dev *dev, u8 idsel, u8 pin)
 {
 	WARN_ON(idsel != 0);
 
@@ -971,7 +969,8 @@ void __init iop13xx_pci_init(void)
 	__raw_writel(__raw_readl(IOP13XX_XBG_BECSR) & 3, IOP13XX_XBG_BECSR);
 
 	/* Setup the Min Address for PCI memory... */
-	iop13xx_pcibios_min_mem = IOP13XX_PCIX_LOWER_MEM_BA;
+	pcibios_min_io = 0;
+	pcibios_min_mem = IOP13XX_PCIX_LOWER_MEM_BA;
 
 	/* if Linux is given control of an ATU
 	 * clear out its prior configuration,
diff -NurpP --minimal linux-3.0/arch/arm/mach-iop13xx/setup.c torvalds-linux-v3.1-rc10/arch/arm/mach-iop13xx/setup.c
--- linux-3.0/arch/arm/mach-iop13xx/setup.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-iop13xx/setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -17,6 +17,7 @@
  *
  */
 
+#include <linux/dma-mapping.h>
 #include <linux/serial_8250.h>
 #include <linux/io.h>
 #ifdef CONFIG_MTD_PHYSMAP
diff -NurpP --minimal linux-3.0/arch/arm/mach-iop32x/em7210.c torvalds-linux-v3.1-rc10/arch/arm/mach-iop32x/em7210.c
--- linux-3.0/arch/arm/mach-iop32x/em7210.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-iop32x/em7210.c	2011-10-18 04:06:23.000000000 +0000
@@ -81,7 +81,7 @@ void __init em7210_map_io(void)
 #define INTD	IRQ_IOP32X_XINT3
 
 static int __init
-em7210_pci_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+em7210_pci_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	static int pci_irq_table[][4] = {
 		/*
diff -NurpP --minimal linux-3.0/arch/arm/mach-iop32x/glantank.c torvalds-linux-v3.1-rc10/arch/arm/mach-iop32x/glantank.c
--- linux-3.0/arch/arm/mach-iop32x/glantank.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-iop32x/glantank.c	2011-10-18 04:06:23.000000000 +0000
@@ -77,7 +77,7 @@ void __init glantank_map_io(void)
 #define INTD	IRQ_IOP32X_XINT3
 
 static int __init
-glantank_pci_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+glantank_pci_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	static int pci_irq_table[][4] = {
 		/*
diff -NurpP --minimal linux-3.0/arch/arm/mach-iop32x/include/mach/hardware.h torvalds-linux-v3.1-rc10/arch/arm/mach-iop32x/include/mach/hardware.h
--- linux-3.0/arch/arm/mach-iop32x/include/mach/hardware.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-iop32x/include/mach/hardware.h	2011-10-18 04:06:23.000000000 +0000
@@ -18,9 +18,6 @@
  * but when we read them, we convert them to virtual addresses. See
  * arch/arm/plat-iop/pci.c.
  */
-#define pcibios_assign_all_busses() 1
-#define PCIBIOS_MIN_IO		0x00000000
-#define PCIBIOS_MIN_MEM		0x00000000
 
 #ifndef __ASSEMBLY__
 void iop32x_init_irq(void);
diff -NurpP --minimal linux-3.0/arch/arm/mach-iop32x/iq31244.c torvalds-linux-v3.1-rc10/arch/arm/mach-iop32x/iq31244.c
--- linux-3.0/arch/arm/mach-iop32x/iq31244.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-iop32x/iq31244.c	2011-10-18 04:06:23.000000000 +0000
@@ -103,7 +103,7 @@ void __init iq31244_map_io(void)
  * EP80219/IQ31244 PCI.
  */
 static int __init
-ep80219_pci_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+ep80219_pci_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	int irq;
 
@@ -139,7 +139,7 @@ static struct hw_pci ep80219_pci __initd
 };
 
 static int __init
-iq31244_pci_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+iq31244_pci_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	int irq;
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-iop32x/iq80321.c torvalds-linux-v3.1-rc10/arch/arm/mach-iop32x/iq80321.c
--- linux-3.0/arch/arm/mach-iop32x/iq80321.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-iop32x/iq80321.c	2011-10-18 04:06:23.000000000 +0000
@@ -71,7 +71,7 @@ void __init iq80321_map_io(void)
  * IQ80321 PCI.
  */
 static int __init
-iq80321_pci_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+iq80321_pci_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	int irq;
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-iop32x/n2100.c torvalds-linux-v3.1-rc10/arch/arm/mach-iop32x/n2100.c
--- linux-3.0/arch/arm/mach-iop32x/n2100.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-iop32x/n2100.c	2011-10-18 04:06:23.000000000 +0000
@@ -78,7 +78,7 @@ void __init n2100_map_io(void)
  * N2100 PCI.
  */
 static int __init
-n2100_pci_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+n2100_pci_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	int irq;
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-iop33x/include/mach/hardware.h torvalds-linux-v3.1-rc10/arch/arm/mach-iop33x/include/mach/hardware.h
--- linux-3.0/arch/arm/mach-iop33x/include/mach/hardware.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-iop33x/include/mach/hardware.h	2011-10-18 04:06:23.000000000 +0000
@@ -18,9 +18,6 @@
  * but when we read them, we convert them to virtual addresses.  See
  * arch/arm/mach-iop3xx/iop3xx-pci.c
  */
-#define pcibios_assign_all_busses()	1
-#define PCIBIOS_MIN_IO		0x00000000
-#define PCIBIOS_MIN_MEM		0x00000000
 
 #ifndef __ASSEMBLY__
 void iop33x_init_irq(void);
diff -NurpP --minimal linux-3.0/arch/arm/mach-iop33x/iq80331.c torvalds-linux-v3.1-rc10/arch/arm/mach-iop33x/iq80331.c
--- linux-3.0/arch/arm/mach-iop33x/iq80331.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-iop33x/iq80331.c	2011-10-18 04:06:23.000000000 +0000
@@ -54,7 +54,7 @@ static struct sys_timer iq80331_timer =
  * IQ80331 PCI.
  */
 static int __init
-iq80331_pci_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+iq80331_pci_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	int irq;
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-iop33x/iq80332.c torvalds-linux-v3.1-rc10/arch/arm/mach-iop33x/iq80332.c
--- linux-3.0/arch/arm/mach-iop33x/iq80332.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-iop33x/iq80332.c	2011-10-18 04:06:23.000000000 +0000
@@ -54,7 +54,7 @@ static struct sys_timer iq80332_timer =
  * IQ80332 PCI.
  */
 static int __init
-iq80332_pci_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+iq80332_pci_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	int irq;
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp2000/enp2611.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp2000/enp2611.c
--- linux-3.0/arch/arm/mach-ixp2000/enp2611.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp2000/enp2611.c	2011-10-18 04:06:23.000000000 +0000
@@ -148,7 +148,8 @@ static struct pci_bus * __init enp2611_p
 	return pci_scan_bus(sys->busnr, &enp2611_pci_ops, sys);
 }
 
-static int __init enp2611_pci_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init enp2611_pci_map_irq(const struct pci_dev *dev, u8 slot,
+	u8 pin)
 {
 	int irq;
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp2000/include/mach/hardware.h torvalds-linux-v3.1-rc10/arch/arm/mach-ixp2000/include/mach/hardware.h
--- linux-3.0/arch/arm/mach-ixp2000/include/mach/hardware.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp2000/include/mach/hardware.h	2011-10-18 04:06:23.000000000 +0000
@@ -19,16 +19,8 @@
 #ifndef __ASM_ARCH_HARDWARE_H__
 #define __ASM_ARCH_HARDWARE_H__
 
-/*
- * This needs to be platform-specific?
- */
-#define PCIBIOS_MIN_IO          0x00000000
-#define PCIBIOS_MIN_MEM         0x00000000
-
 #include "ixp2000-regs.h"	/* Chipset Registers */
 
-#define pcibios_assign_all_busses() 0
-
 /*
  * Platform helper functions
  */
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp2000/ixdp2400.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp2000/ixdp2400.c
--- linux-3.0/arch/arm/mach-ixp2000/ixdp2400.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp2000/ixdp2400.c	2011-10-18 04:06:23.000000000 +0000
@@ -78,7 +78,8 @@ int ixdp2400_pci_setup(int nr, struct pc
 	return 1;
 }
 
-static int __init ixdp2400_pci_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init ixdp2400_pci_map_irq(const struct pci_dev *dev, u8 slot,
+	u8 pin)
 {
 	if (ixdp2x00_master_npu()) {
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp2000/ixdp2800.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp2000/ixdp2800.c
--- linux-3.0/arch/arm/mach-ixp2000/ixdp2800.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp2000/ixdp2800.c	2011-10-18 04:06:23.000000000 +0000
@@ -161,7 +161,8 @@ static int __init ixdp2800_pci_setup(int
 	return 1;
 }
 
-static int __init ixdp2800_pci_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init ixdp2800_pci_map_irq(const struct pci_dev *dev, u8 slot,
+	u8 pin)
 {
 	if (ixdp2x00_master_npu()) {
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp2000/ixdp2x01.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp2000/ixdp2x01.c
--- linux-3.0/arch/arm/mach-ixp2000/ixdp2x01.c	2011-06-22 15:07:10.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp2000/ixdp2x01.c	2011-10-18 04:06:23.000000000 +0000
@@ -252,7 +252,8 @@ void __init ixdp2x01_pci_preinit(void)
 
 #define DEVPIN(dev, pin) ((pin) | ((dev) << 3))
 
-static int __init ixdp2x01_pci_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init ixdp2x01_pci_map_irq(const struct pci_dev *dev, u8 slot,
+	u8 pin)
 {
 	u8 bus = dev->bus->number;
 	u32 devpin = DEVPIN(PCI_SLOT(dev->devfn), pin);
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp2000/pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp2000/pci.c
--- linux-3.0/arch/arm/mach-ixp2000/pci.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp2000/pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -196,6 +196,11 @@ clear_master_aborts(void)
 void __init
 ixp2000_pci_preinit(void)
 {
+	pci_set_flags(0);
+
+	pcibios_min_io = 0;
+	pcibios_min_mem = 0;
+
 #ifndef CONFIG_IXP2000_SUPPORT_BROKEN_PCI_IO
 	/*
 	 * Configure the PCI unit to properly byteswap I/O transactions,
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp23xx/include/mach/hardware.h torvalds-linux-v3.1-rc10/arch/arm/mach-ixp23xx/include/mach/hardware.h
--- linux-3.0/arch/arm/mach-ixp23xx/include/mach/hardware.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp23xx/include/mach/hardware.h	2011-10-18 04:06:23.000000000 +0000
@@ -15,13 +15,9 @@
 #define __ASM_ARCH_HARDWARE_H
 
 /* PCI IO info */
-#define PCIBIOS_MIN_IO		0x00000000
-#define PCIBIOS_MIN_MEM		0xe0000000
 
 #include "ixp23xx.h"
 
-#define pcibios_assign_all_busses()	0
-
 /*
  * Platform helper functions
  */
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp23xx/ixdp2351.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp23xx/ixdp2351.c
--- linux-3.0/arch/arm/mach-ixp23xx/ixdp2351.c	2011-06-22 15:07:10.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp23xx/ixdp2351.c	2011-10-18 04:06:23.000000000 +0000
@@ -168,7 +168,7 @@ void __init ixdp2351_init_irq(void)
  */
 #define DEVPIN(dev, pin) ((pin) | ((dev) << 3))
 
-static int __init ixdp2351_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init ixdp2351_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	u8 bus = dev->bus->number;
 	u32 devpin = DEVPIN(PCI_SLOT(dev->devfn), pin);
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp23xx/pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp23xx/pci.c
--- linux-3.0/arch/arm/mach-ixp23xx/pci.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp23xx/pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -227,6 +227,11 @@ static void __init ixp23xx_pci_common_in
 
 void __init ixp23xx_pci_preinit(void)
 {
+	pcibios_min_io = 0;
+	pcibios_min_mem = 0xe0000000;
+
+	pci_set_flags(0);
+
 	ixp23xx_pci_common_init();
 
 	hook_fault_code(16+6, ixp23xx_pci_abort_handler, SIGBUS, 0,
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp23xx/roadrunner.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp23xx/roadrunner.c
--- linux-3.0/arch/arm/mach-ixp23xx/roadrunner.c	2011-06-22 15:07:10.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp23xx/roadrunner.c	2011-10-18 04:06:23.000000000 +0000
@@ -56,7 +56,8 @@
 #define INTC_PIN	IXP23XX_GPIO_PIN_11
 #define INTD_PIN	IXP23XX_GPIO_PIN_12
 
-static int __init roadrunner_map_irq(struct pci_dev *dev, u8 idsel, u8 pin)
+static int __init roadrunner_map_irq(const struct pci_dev *dev, u8 idsel,
+	u8 pin)
 {
 	static int pci_card_slot_irq[] = {INTB, INTC, INTD, INTA};
 	static int pmc_card_slot_irq[] = {INTA, INTB, INTC, INTD};
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/avila-pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/avila-pci.c
--- linux-3.0/arch/arm/mach-ixp4xx/avila-pci.c	2011-06-22 15:07:11.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/avila-pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -46,7 +46,7 @@ void __init avila_pci_preinit(void)
 	ixp4xx_pci_preinit();
 }
 
-static int __init avila_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init avila_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	static int pci_irq_table[IRQ_LINES] = {
 		IXP4XX_GPIO_IRQ(INTA),
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/avila-setup.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/avila-setup.c
--- linux-3.0/arch/arm/mach-ixp4xx/avila-setup.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/avila-setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -169,6 +169,9 @@ MACHINE_START(AVILA, "Gateworks Avila Ne
 	.timer		= &ixp4xx_timer,
 	.boot_params	= 0x0100,
 	.init_machine	= avila_init,
+#if defined(CONFIG_PCI)
+	.dma_zone_size	= SZ_64M,
+#endif
 MACHINE_END
 
  /*
@@ -184,6 +187,9 @@ MACHINE_START(LOFT, "Giant Shoulder Inc
 	.timer		= &ixp4xx_timer,
 	.boot_params	= 0x0100,
 	.init_machine	= avila_init,
+#if defined(CONFIG_PCI)
+	.dma_zone_size	= SZ_64M,
+#endif
 MACHINE_END
 #endif
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/common-pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/common-pci.c
--- linux-3.0/arch/arm/mach-ixp4xx/common-pci.c	2011-08-29 03:03:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/common-pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -316,6 +316,11 @@ static int abort_handler(unsigned long a
 }
 
 
+static int ixp4xx_needs_bounce(struct device *dev, dma_addr_t dma_addr, size_t size)
+{
+	return (dma_addr + size) >= SZ_64M;
+}
+
 /*
  * Setup DMA mask to 64MB on PCI devices. Ignore all other devices.
  */
@@ -324,7 +329,7 @@ static int ixp4xx_pci_platform_notify(st
 	if(dev->bus == &pci_bus_type) {
 		*dev->dma_mask =  SZ_64M - 1;
 		dev->coherent_dma_mask = SZ_64M - 1;
-		dmabounce_register_dev(dev, 2048, 4096);
+		dmabounce_register_dev(dev, 2048, 4096, ixp4xx_needs_bounce);
 	}
 	return 0;
 }
@@ -337,15 +342,15 @@ static int ixp4xx_pci_platform_notify_re
 	return 0;
 }
 
-int dma_needs_bounce(struct device *dev, dma_addr_t dma_addr, size_t size)
-{
-	return (dev->bus == &pci_bus_type ) && ((dma_addr + size) >= SZ_64M);
-}
-
 void __init ixp4xx_pci_preinit(void)
 {
 	unsigned long cpuid = read_cpuid_id();
 
+#ifdef CONFIG_IXP4XX_INDIRECT_PCI
+	pcibios_min_mem = 0x10000000; /* 1 GB of indirect PCI MMIO space */
+#else
+	pcibios_min_mem = 0x48000000; /* 64 MB of PCI MMIO space */
+#endif
 	/*
 	 * Determine which PCI read method to use.
 	 * Rev 0 IXP425 requires workaround.
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/coyote-pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/coyote-pci.c
--- linux-3.0/arch/arm/mach-ixp4xx/coyote-pci.c	2011-06-22 15:07:11.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/coyote-pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -37,7 +37,7 @@ void __init coyote_pci_preinit(void)
 	ixp4xx_pci_preinit();
 }
 
-static int __init coyote_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init coyote_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	if (slot == SLOT0_DEVID)
 		return IXP4XX_GPIO_IRQ(SLOT0_INTA);
